# -*- coding: utf8 -*-

# Copyright 2009 laliputienses
# License: GPL v3
# For further info, see LICENSE file

import re

# this is the only stuff from lalita you need to import
from lalita import Plugin


class Ticket(Plugin):
    def init(self, config):
        # log that we started
        self.logger.info("Init! config: %s", config)

        # register our methods to the events
        self.register(self.events.COMMAND, self.command_trac, ['trac'])
        self.register(self.events.PUBLIC_MESSAGE, self.message)

        self.trac_urls = {}

        self.regex = re.compile(r'#(?P<nticket>\d+)')

    def command_trac(self, user, channel, command, *args):
        u'''trac url: guarda esa url para luego agregarle el número de ticket recibido'''
        if args:
            try:
                url = args[0]
            except IndexError:
                url = ''
            self.trac_urls[user] = url

    def message(self, user, channel, message):
        u'''busca #<ticket_num> para usar con la url definida por el usuario'''
        search = self.regex.search(message)
        if search != None:
            regex_dict = search.groupdict()
            if regex_dict.has_key('nticket') and user in self.trac_urls.keys():
                self.say(channel, "URL Ticket: " + self.trac_urls[user] + regex_dict['nticket'])
